@* The entropy of a functional.
@c
/* Empty, waiting for |export| */
@ @(functional/entr.h@>=
#ifndef __MATH_ENTROPY_FUNCTIONAL__
#define __MATH_ENTROPY_FUNCTIONAL__ 1.00
#include <math.h>
#include <math/functionalbase.h>
namespace math
{
    @[namespace functional@]
    {
	template<class T>@;
	class @[entr : public base<T>@]
	{
	    @<Entropy of a functional internal variables@>@;
	public:@;
	    @<Entropy of a functional class methods@>@;
	};
    }
}
#endif
@ @<Entropy of a functional internal variables@>=
typedef base<T>* element_type;
element_type f;
@ @<Entropy of a functional class methods@>=
entr(element_type new_f) @[:@] f(new_f) @+{@+}
@ @<Entropy of a functional class methods@>=
T eval(const matrix<T,unstructured,dense>& x)
{
    T result=f->eval(x);
    if(result<=0) throw error::domain();
    return -result*::log(result);
}
@ The gradient of the entropy is given by $-(1+\log f)\nabla f$.
@ @<Entropy of a functional class methods@>=
matrix<T,unstructured,dense>& grad(const matrix<T,unstructured,dense>& x,
				   matrix<T,unstructured,dense>& dest)
{
    T result=f->eval(x);
    if(result<=0) throw error::domain();
    f->grad(x,dest);
    return dest*=-(::log(result)+1);
}
@ The Hessian is given by $-(1+\log f)\nabla^2 f-(1/f)\nabla f\nabla^T f$.
@<Entropy of a functional internal variables@>=
matrix<T,symmetric,dense> Hdense;
matrix<T,symmetric,sparse> Hsparse;
matrix<T,unstructured,dense> aux;
@ @<Entropy of a functional class methods@>=
matrix<T,symmetric,dense> &hess(const matrix<T,unstructured,dense>&x, matrix<T,symmetric,dense>&
				dest)
{
    T result=f->eval(x);
    if(result<=0) throw error::domain();
    f->grad(x,aux);
    outerp(aux,&Hdense);
    Hdense/=(-result);
    f->hess(x,dest);
    dest*=-(::log(result)+1);
    return dest+=Hdense;
}
matrix<T,symmetric,sparse> &hess(const matrix<T,unstructured,dense>&x, matrix<T,symmetric,sparse>&
				dest)
{
    T result=f->eval(x);
    if(result<=0) throw error::domain();
    f->grad(x,aux);
    outerp(aux,&Hsparse);
    Hsparse/=(-result);
    f->hess(x,dest);
    dest*=-(::log(result)+1);
    return dest+=Hsparse;
}
