@* The Error Function. The error function (erf) is defined as $${\rm erf}(x)=\frac{2}{\sqrt\pi}
 \int_0^x \exp{-u^2}du$$
@c
/* Empty, waiting for |export| */
@ @(functional/erf.h@>=
#ifndef __MATH_ERF_FUNCTIONAL__
#define __MATH_ERF_FUNCTIONAL__ 1.00
#include <math.h>
#include <math/functionalbase.h>
namespace math
{
   namespace functional
     {
	template<class T>@;@q..@>
	  class @[erf : public base<T>@]@q..@>
	  {
	     @<Error function of a functional internal variables@>@;@q..@>
	   public:@;@q..@>
	       @<Error function of a functional class methods@>@;@q..@>
	  };
     }
}
#endif
@ @<Error function  of a functional internal variables@>=
typedef base<T>* element_type;
element_type f;
@ @<Error function  of a functional class methods@>=
erf(element_type new_f) @[:@] f(new_f) @+@q..@>{}
@ @<Error function  of a functional class methods@>=
T eval(const matrix<T,unstructured,dense>& x)
{ return(::erf(f->eval(x))); }
@ The gradient of the error function is given by $\frac2{\sqrt\pi}\exp{-f^2}\nabla f$.
@ @<Error function  of a functional class methods@>=
matrix<T,unstructured,dense>& grad(const matrix<T,unstructured,dense>& x,
				   matrix<T,unstructured,dense>& dest)
{
   T result=f->eval(x);
   f->grad(x,dest);
   return dest*=2/::sqrt(M_PI)*::exp(-result*result);
}
@ The Hessian is given by $\frac2{\sqrt\pi}\exp{-f^2}\nabla^2 f
 -\frac4{\sqrt\pi}f\exp{-f^2}\nabla\nabla^Tf$.
@<Error function  of a functional internal variables@>=
matrix<T,symmetric,dense> dense_aux;
matrix<T,symmetric,sparse> sparse_aux;
matrix<T,unstructured,dense> aux;
@ @<Error function  of a functional class methods@>=
matrix<T,symmetric,dense> &hess(const matrix<T,unstructured,dense>&x, matrix<T,symmetric,dense>&
				dest)
{
#define hess_aux dense_aux
   @<Compute Hessian for |erf| functional@>;
#undef hess_aux
}
matrix<T,symmetric,sparse> &hess(const matrix<T,unstructured,dense>&x, matrix<T,symmetric,sparse>&
				dest)
{
#define hess_aux sparse_aux
   @<Compute Hessian for |erf| functional@>;
#undef hess_aux
}
@ @<Compute Hessian for |erf| functional@>=
T result=f->eval(x);
f->grad(x,aux);
f->hess(x,dest);
outerp(aux,&hess_aux);
hess_aux*=-2*result;
dest+=hess_aux;
return dest*=2*::exp(-result*result)/::sqrt(M_PI);
